/****************************************************************************

    Guptachar Remote Administration Tool Installation Program
    Copyright (C) 2001 Ayan Chakrabarti

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

****************************************************************************/

#include <stdio.h>
#include <conio.h>
#include <windows.h>

void conv_base64(char * input,char * output)
{
        int len,n,i,j = 0;
        char c1,c2,c3,o1,o2,o3,o4;
        char table[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";


        len = strlen(input);
        n = len/3;

        for(i = 0;i < n;i++)
        {
             c1 = input[i*3];
             c2 = input[i*3+1];
             c3 = input[i*3+2];

             o1 = (c1 >> 2) & 0x3F;
             
             o2 = c1 & 0x03;
             o2 <<= 4;
             o2 &= 0xF0;
             c1 = c2 >> 4;
             c1 &= 0x0F;
             o2 += c1;

             o3 = c2 & 0x0F;
             o3 <<= 2;
             o3 &= 0xFC;
             c2 = c3 >> 6;
             c2 &= 0x03;
             o3 += c2;

             o4 = c3 & 0x3F;

             output[j++] = table[o1];
             output[j++] = table[o2];
             output[j++] = table[o3];
             output[j++] = table[o4];
        }

        if(len % 3 == 0)
        {
                output[j] = '\0';
                return;
        }

        if(len % 3 == 1)
        {
                c1 = input[len-1];
                c2 = 0;
        }

        if(len %3 == 2)
        {
                c1 = input[len-2];
                c2 = input[len-1];
        }

        c3 = 0;

        o1 = (c1 >> 2) & 0x3F;
             
        o2 = c1 & 0x03;
        o2 <<= 4;
        o2 &= 0xF0;
        c1 = c2 >> 4;
        c1 &= 0x0F;
        o2 += c1;
                         
        o3 = c2 & 0x0F;
        o3 <<= 2;
        o3 &= 0xFC;
        c2 = c3 >> 6;
        c2 &= 0x03;
        o3 += c2;

        o4 = c3 & 0x3F;

        output[j++] = table[o1];
        output[j++] = table[o2];
        output[j++] = table[o3];
        output[j++] = table[o4];

        output[j] = '\0';

        for(i = 0;i < (3 - len%3);i++)
                output[--j] = '=';
}


int main()
{
        int ch;
        char buf[256],buf2[256],pwdid[256],ihost[256],inick[256];
        unsigned int isirc,iport;
        FILE *fp1,*fp2;
        char fn[1024];

        clrscr();

        printf("Guptachar Remote Administration Tool\n");
        printf("Copyright (C) 2001 Ayan Chakrabarti\n\n");

        printf("This program is free software; you can redistribute it and/or modify\n");
        printf("it under the terms of the GNU General Public License as published by\n");
        printf("the Free Software Foundation; either version 2 of the License, or\n");
        printf("(at your option) any later version.\n\n");

        printf("This program is distributed in the hope that it will be useful,\n");
        printf("but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
        printf("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
        printf("GNU General Public License for more details.\n\n");

        printf("You should have received a copy of the GNU General Public License\n");
        printf("along with this program; if not, write to the Free Software\n");
        printf("Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.\n\n");

        printf("Installation Program\n");
        printf("--------------------\n\n");

        printf("Do you want to install Guptachar on this system ? (y/n): ");
        gets(buf);
        ch = buf[0];
        if(ch != 'y' && ch != 'Y')
                return -1;

        printf("\n\nPlease answer the following questions:\n\n");

        printf("Server Authentication\n");
        printf("   Username: ");
        gets(buf);
        strcpy(buf2,buf);
        printf("   Password: ");
        gets(buf);
        strcat(buf2,":");
        strcat(buf2,buf);
        conv_base64(buf2,pwdid);

        printf("\nIRC Bot Management\n");
        printf("==================\n");
        printf("The IRC bot helps keep track of the IP address of the machine to be\n");
        printf("administrated. This is only helpful if the machine has a variable IP\n");
        printf("address.\n");
        printf("The IRC bot will first detect if the machine is online by getting the primary\n");
        printf("IP address of the machine. If it does not begin with 127, the bot assumes\n");
        printf("that the machine is online. Then it will connect to an IRC server of your\n");
        printf("choice with the nickname of your choice. If the nickname is already\n");
        printf("registered, it will log on with an alternative nickname which begins with\n");
        printf("the nickname you gave. So, to get the machine's IP address, all you have to\n");
        printf("do is to connect to the same IRC server yourself and then do a /who with the\n");
        printf("nickname you chose.\n\n");
        printf("Do you want the IRC bot to be active ? <y/n>");
        gets(buf);
        ch = buf[0];

        if(ch != 'Y' && ch != 'y')
                isirc = 0;
        else
        {
                isirc = 1;
                printf("\n   IRC Host Address: ");
                gets(ihost);
                printf("   IRC Host Port (usually 6667): ");
                scanf("%i",&iport);
                gets(inick);
                printf("   IRC Nick: ");
                gets(inick);
        }
        printf("\nInstalling .....");

        GetWindowsDirectory(fn,1000);
        strcat(fn,"\\Gupt.exe");

        fp1 = fopen("Gupt.exe","rb");
        if(!fp1)
        {
                printf("\n\nError: Gupt.exe not found.\n");
                printf("Ensure Gupt.exe is in current directory and try again.\n");
                return -1;
        }
        fp2 = fopen(fn,"wb");
        if(!fp2)
        {
                fclose(fp1);
                printf("\n\nError: Unable to create output file.\n\n");
                return -1;
        }

        ch = fgetc(fp1);
        while(!feof(fp1))
        {
                fputc(ch,fp2);
                ch = fgetc(fp1);
        }
        fclose(fp1);
        fclose(fp2);

        WriteProfileString("windows","run",fn);
        WriteProfileString("GSRV","pwdid",pwdid);

        if(isirc)
        {
                strcpy(buf,"1");
                itoa(iport,buf2,10);
        }
        else
                strcpy(buf,"0");

        WriteProfileString("GSRV","isirc",buf);
        if(isirc)
        {
                WriteProfileString("GSRV","inick",inick);
                WriteProfileString("GSRV","ihost",ihost);
                WriteProfileString("GSRV","iport",buf2);
        }

        printf("\n\nInstallation complete.\n");
        printf("View the README file to find out how to uninstall Guptachar.\n\n");
        printf("Do you want to start the Guptachar server now ? <y/n>");
        gets(buf);
        ch = buf[0];

        if(ch == 'Y' || ch == 'y')
                WinExec(fn,0);

        return 0;
}
