/****************************************************************************

    Guptachar Remote Administration Tool
    Copyright (C) 2001 Ayan Chakrabarti

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    IRC.C
    =====
    The code to implement an IRC bot which connects to a given IRC server
    with a given nick or its permutation and stays on, responding to any
    PING requests when necessary.

****************************************************************************/


#include <winsock.h>
#include <string.h>

char buf[1024];
int  bpos;

int docheck(char * str)
{
        int i,j;
        for(i = 0;i < bpos;i++)
                if(buf[i] == '\r' || buf[i] == '\n')
                        break;
        if(i == bpos)
                return 0;

        for(j = 0;j < i;j++)
                str[j] = buf[j];

        str[j] = '\0';

        for(;(buf[i] == '\r' || buf[i] == '\n') && i < bpos;i++);

        for(j = 0;i < bpos;i++,j++)
                buf[j] = buf[i];
        bpos = j;
        return 1;
}

int readline(SOCKET s,char * str)
{
        int n;

        while(1)
        {
                if(docheck(str))
                        return 1;
                if(bpos >= 1023)
                        bpos = 0;
                n = recv(s,&buf[bpos],1023-bpos,0);
                if(n <= 0)
                        return 0;
                bpos += n;
                
        }
}

void makenick(char * user, unsigned int * np, char * nick)
{
        unsigned int i,j;

        for(i = 0;user[i] != '\0';i++)
                nick[i] = user[i];
        (*np)++;

        j = *np;
        while(j != 0)
        {
                nick[i++] = '0' + j % 10;
                j /= 10;
        }
        nick[i] = '\0';
}

void doirc(char * host,unsigned int port,char * user)
{
        SOCKET s;
        char nick[512];
        struct hostent * hs;
        struct sockaddr_in sa;
        char outb[1024],buf2[1024];
        unsigned int np = 0,i;

        strcpy(nick,user);
        bpos = 0;

        sa.sin_family = AF_INET;
        sa.sin_port = htons(port);
        if((sa.sin_addr.s_addr = inet_addr(host)) == -1)
        {
                if((hs = gethostbyname(host)) == NULL)
                        return;
                memcpy(&sa.sin_addr,hs->h_addr,sizeof(struct in_addr));
        }

        s = socket(AF_INET,SOCK_STREAM,0);
        if(s == INVALID_SOCKET)
                return;

        if(connect(s,(struct sockaddr *)&sa,sizeof(sa)) < 0)
                return;

        strcpy(outb,"NICK ");
        strcat(outb,nick);
        strcat(outb,"\r\nUSER ");
        strcat(outb,nick);
        strcat(outb," 0 * :Guptachar IRCBOT\r\n");
        send(s,outb,strlen(outb),0);

        while(1)
        {
                if(!readline(s,buf2))
                        break;

                if(strncmpi(buf2,"PING ",5) == 0)
                {
                        buf2[1] = 'O';
                        strcpy(outb,buf2);
                        strcat(outb,"\r\n");
                        send(s,outb,strlen(outb),0);
                }
                else
                {
                        for(i = 0;buf2[i] != ' ' && buf2[i] != '\0';i++);
                        for(;buf2[i] == ' ';i++);
                        if(strncmp(&buf2[i],"433",3) == 0)
                        {
                                makenick(user,&np,nick);
                                strcpy(outb,"NICK ");
                                strcat(outb,nick);
                                strcat(outb,"\r\n");
                                send(s,outb,strlen(outb),0);
                        }
                        
                }
        }
        closesocket(s);
        
}
