/****************************************************************************

    Guptachar Upload Utility
    Copyright (C) 2001 Ayan Chakrabarti

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

****************************************************************************/

#include <string.h>
#include <stdio.h>
#include <winsock.h>

char buf[1024];
int  bpos;

int docheck(char * str)
{
        int i,j;
        for(i = 0;i < bpos;i++)
                if(buf[i] == '\r' || buf[i] == '\n')
                        break;
        if(i == bpos)
                return 0;

        for(j = 0;j < i;j++)
                str[j] = buf[j];

        str[j] = '\0';

        i++;
        if(buf[i] == '\r' || buf[i] == '\n')
                i++;

        for(j = 0;i < bpos;i++,j++)
                buf[j] = buf[i];
        bpos = j;
        return 1;
}

int readline(SOCKET s,char * str)
{
        int n;

        while(1)
        {
                if(docheck(str))
                        return 1;
                if(bpos >= 1023)
                        bpos = 0;
                n = recv(s,&buf[bpos],1023-bpos,0);
                if(n <= 0)
                        return 0;
                bpos += n;
                
        }
}



void conv_base64(char * input,char * output)
{
        int len,n,i,j = 0;
        char c1,c2,c3,o1,o2,o3,o4;
        char table[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";


        len = strlen(input);
        n = len/3;

        for(i = 0;i < n;i++)
        {
             c1 = input[i*3];
             c2 = input[i*3+1];
             c3 = input[i*3+2];

             o1 = (c1 >> 2) & 0x3F;
             
             o2 = c1 & 0x03;
             o2 <<= 4;
             o2 &= 0xF0;
             c1 = c2 >> 4;
             c1 &= 0x0F;
             o2 += c1;

             o3 = c2 & 0x0F;
             o3 <<= 2;
             o3 &= 0xFC;
             c2 = c3 >> 6;
             c2 &= 0x03;
             o3 += c2;

             o4 = c3 & 0x3F;

             output[j++] = table[o1];
             output[j++] = table[o2];
             output[j++] = table[o3];
             output[j++] = table[o4];
        }

        if(len % 3 == 0)
        {
                output[j] = '\0';
                return;
        }

        if(len % 3 == 1)
        {
                c1 = input[len-1];
                c2 = 0;
        }

        if(len %3 == 2)
        {
                c1 = input[len-2];
                c2 = input[len-1];
        }

        c3 = 0;

        o1 = (c1 >> 2) & 0x3F;
             
        o2 = c1 & 0x03;
        o2 <<= 4;
        o2 &= 0xF0;
        c1 = c2 >> 4;
        c1 &= 0x0F;
        o2 += c1;
                         
        o3 = c2 & 0x0F;
        o3 <<= 2;
        o3 &= 0xFC;
        c2 = c3 >> 6;
        c2 &= 0x03;
        o3 += c2;

        o4 = c3 & 0x3F;

        output[j++] = table[o1];
        output[j++] = table[o2];
        output[j++] = table[o3];
        output[j++] = table[o4];

        output[j] = '\0';

        for(i = 0;i < (3 - len%3);i++)
                output[--j] = '=';
}


char host[1024],lname[1024],rname[1024],user[1024],pass[1024];

void doupload(void)
{
        SOCKET  httpl,httpc,s;
        struct  sockaddr_in addr;
        struct hostent * hs;
        struct hostent far * he;
        struct sockaddr_in sa;
        FILE * fp1;
        char outb[1024],buf[1024];
        char name[257];
        int i,j,c;

        bpos = 0;

        fp1 = fopen(lname,"rb");
        if(!fp1)
        {
                printf("Unable to open local file !\n");
                return;
        }

        sa.sin_family = AF_INET;
        sa.sin_port = htons(80);
        if((sa.sin_addr.s_addr = inet_addr(host)) == -1)
        {
                if((hs = gethostbyname(host)) == NULL)
                {
                        printf("Error resolving hostname\n");
                        fclose(fp1);
                        return;
                }
                memcpy(&sa.sin_addr,hs->h_addr,sizeof(struct in_addr));
        }

        s = socket(AF_INET,SOCK_STREAM,0);
        if(s == INVALID_SOCKET)
        {
                printf("Error creating socket !\n");
                fclose(fp1);
                return;
        }

   
        printf("Starting temporary web server on port 80 !\n");
        httpl = socket(AF_INET,SOCK_STREAM,0);
        addr.sin_family = AF_INET;
        addr.sin_port = htons(80);
        addr.sin_addr.s_addr = INADDR_ANY;
        bind(httpl,&addr,sizeof(addr));
        listen(httpl,10);

        printf("Connecting to Guptachar server !\n");
        if(connect(s,(struct sockaddr *)&sa,sizeof(sa)) < 0)
        {
                closesocket(httpl);
                printf("Error connecting !\n");
                fclose(fp1);
                return;
        }


        printf("Connected ! Sending transfer request ... \n");
        strcpy(outb,"GET /transfer?u=");
        gethostname(name,256);
	he = gethostbyname(name);
        strcat(outb,inet_ntoa(*( (struct in_addr *) he->h_addr ) ) );
        strcat(outb,"&p=");

        for(i=j=0;rname[i] != '\0';i++)
        {
                 c = rname[i];
                 if( (c < 'A' || c > 'Z') && (c < 'a' || c > 'z') && (c < '0' || c > '9') && c!='.')
                 {
                        buf[j++] = '%';
                        if(c % 16 > 9)
                                buf[j+1] = 'A' + (c%16) - 10;
                        else
                                buf[j+1] = '0' + (c%16);
                        c/=16;
                        if(c % 16 > 9)
                                buf[j] = 'A' + (c%16) - 10;
                        else
                                buf[j] = '0' + (c%16);
                        j+=2;

                 }
                 else buf[j++] = rname[i];
        }

        buf[j] = '\0';
        strcat(outb,buf);
        strcat(outb," HTTP/1.0\r\nAuthorization: Basic ");
        send(s,outb,strlen(outb),0);
        strcpy(buf,user);
        strcat(buf,":");
        strcat(buf,pass);
        conv_base64(buf,outb);
        strcat(outb,"\r\n\r\n");
        send(s,outb,strlen(outb),0);

        i = 0;
        while(i < 4)
                i+= recv(s,&buf[i],1023-i,0);

        closesocket(s);

        if(strncmp(buf,"HTTP/1.0 401",12) != 0)
                printf("Request accepted.\n");
        else
        {
                printf("Authentication failure.\n");
                closesocket(httpl);
                fclose(fp1);
                return;
        }

        httpc = accept(httpl,NULL,NULL);
        printf("Accepted Connection !\n");
        closesocket(httpl);

        
        while(1)
        {
                if(!readline(httpc,buf))
                {
                        printf("Error Transferring file !\n");
                        fclose(fp1);
                        closesocket(httpc);
                        return;
                }
                if(buf[0] == '\0')
                        break;
        }

        printf("Transferring file ");
        strcpy(buf,"HTTP/1.0 200 OK\r\n\r\n");
        send(s,buf,strlen(buf),0);

        do
        {
                i = fread(buf,1,1023,fp1);
                printf(".");
                if(i != 0)
                        send(httpc,buf,i,0);
        } while(i >= 1023);

        printf("\nTransfer Completed!\n");
        closesocket(httpc);
        fclose(fp1);
}

int main(int argc,char ** argv)
{
        WSADATA ws;
        
        printf("Guptachar Upload Utility\n");
        printf("Copyright (C) 2001 Ayan Chakrabarti\n\n");
        
        if(argc != 6)
        {
                printf("This program is free software; you can redistribute it and/or modify\n");
                printf("it under the terms of the GNU General Public License as published by\n");
                printf("the Free Software Foundation; either version 2 of the License, or\n");
                printf("(at your option) any later version.\n\n");

                printf("This program is distributed in the hope that it will be useful,\n");
                printf("but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
                printf("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
                printf("GNU General Public License for more details.\n\n");

                printf("You should have received a copy of the GNU General Public License\n");
                printf("along with this program; if not, write to the Free Software\n");
                printf("Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.\n\n");

                printf("USAGE: UPLOAD host localfilename remotefilename username password\n");
                printf("where, host           - IP Address or hostname of Guptachar server.\n");
                printf("       localfilename  - The path of the file to be uploaded.\n");
                printf("       remotefilename - The path for storing the file on the remote system.\n");
                printf("       username       - Username for Guptachar server\n");
                printf("       password       - Password for Guptachar server\n");
                return 0;
        }

        WSAStartup(0x101,&ws);

        strcpy(host,argv[1]);
        strcpy(lname,argv[2]);
        strcpy(rname,argv[3]);
        strcpy(user,argv[4]);
        strcpy(pass,argv[5]);
        doupload();

        WSACleanup();
        return 0;
}
